#!/usr/bin/python3

'''
Before running this program, you need to install postgeSQL and enable remote TCP/IP access to it.

files to edit:
/etc/postgresql/12/main/pg_hba.conf
/etc/postgresql/12/main/postgresql.conf

Need to create a Database and Role (for example, DBNAME)
$ sudo -su postgres
$ psql

create role DBNAME with createrole login password 'password';
create database DBNAME;
grant all on database DBNAME to DBNAME;
create user dummy with password 'dum123';
------------------------------------------------

This program creates:
table coursedetails
table logo
permit user 'dummy' to read coursedetails 
'''

import psycopg2, sys, getpass

if len(sys.argv) != 3:
	print ('Usage: python3 initQbank.py hostname databasename')
	sys.exit(0)

host = sys.argv[1]
mydb = sys.argv[2]

passwd = getpass.getpass('Enter Database password : ')

print(host, mydb, passwd)
conn = psycopg2.connect(database=mydb, host=host, user=mydb, password=passwd)
cursor = conn.cursor()

sql = 'create table if not exists coursedetails(code varchar, name varchar, subject varchar, degree varchar, syllabusYear varchar, semester varchar, texLanguage varchar, qpmodel varchar, duration varchar, nmodules varchar);'
try:
	cursor.execute(sql)
	print('Table "coursedetails" created')
	conn.commit()	
except:
	print('Creating Table "coursedetails" failed')
	sys.exit(0)

sql = 'grant select on coursedetails to reader;'
cursor.execute(sql)
conn.commit()	

sql = 'grant select on coursedetails to dummy;'
cursor.execute(sql)
conn.commit()	
